#include "StdAfx.h"
#include "SmeexHandler.h"


CSmeexHandler::CSmeexHandler(void)
{
	f_psSmeexOnePatientComm=NULL;
	f_strAttachmentDir = _T("");
}

CSmeexHandler::~CSmeexHandler()
{
	try {
 		f_mapAddress.Clear();
 		f_mapDocument.Clear();
 		f_mapCodingEntry.Clear();
		f_mapDocumentsImportedID.Clear();
	}
	catch (...) {
	}
}

BOOL CSmeexHandler::IsValidDate(const DATE &date)
{
	BOOL bReturn = FALSE;
	if (date<=COleDateTime(SMEEX_EMPTY_OLEDATETIME)) {
		return bReturn;
	}
	COleDateTime dateTime = date;
	bReturn = dateTime.GetStatus()==COleDateTime::valid ? TRUE : FALSE;
	ASSERT(bReturn);
	return bReturn;
}

CString CSmeexHandler::BuildCodingEntryKey(const _bstr_t &strCodingEntryCode,const _bstr_t &strCodingEntryName)
{
	CString strReturn = strCodingEntryCode +_T("_") + strCodingEntryName;
	return strReturn;
}

BOOL CSmeexHandler::DoSmeexExport(const CString &strFilename,
								structSmeexOnePatientComm *psSmeexOnePatientComm)
{
	BOOL bReturn = FALSE;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure;
	if (!pSmeexStructure) {
		ASSERT(psSmeexOnePatientComm!=NULL);
		pSmeexStructure = gcnew Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure(gcnew System::String((TCHAR*)psSmeexOnePatientComm->sSmeexArchive.strSmeexID));
		if (!pSmeexStructure) {
			ASSERT(FALSE);
			return bReturn;
		}
	}
	f_psSmeexOnePatientComm=psSmeexOnePatientComm;
	ASSERT(pSmeexStructure&&f_psSmeexOnePatientComm);
	//
	DoExportProcessingInfo(pSmeexStructure);
	//
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo = pSmeexStructure->NewPatientInfo();
	if (!pPatientInfo) {
		ASSERT(FALSE);
		return bReturn;
	}
	DoExportPatientInfo(pSmeexStructure,pPatientInfo);
	//
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG = pPatientInfo->NewKg();
	if (!pKG) {
		ASSERT(FALSE);
		return bReturn;
	}
	DoExportKg(pSmeexStructure,pKG);
	//
	DoExportDocumentTree(pSmeexStructure,pPatientInfo);
	//
#pragma message("NOTE: Arcive is protected in Smeex-Class!!!!!")
	System::String ^strExportFile = gcnew System::String(strFilename);
	{
		Vsfm::Smeex::Framework::Common::Archive ^pArchive = pSmeexStructure->Save();
		TRACE("%ls\n",(const TCHAR*)CString(pArchive->Path));
	}
	Vsfm::Smeex::Framework::Common::Archive ^pArchive = pSmeexStructure->Save(strExportFile);
	if (pArchive) {
		pSmeexStructure->~SmeexStructure();
		pArchive->Language = gcnew System::String((TCHAR*)f_psSmeexOnePatientComm->sSmeexArchive.strLanguage);
		pArchive->Title = gcnew System::String((TCHAR*)f_psSmeexOnePatientComm->sSmeexArchive.strTitle);
		pArchive->Save();
		TRACE("%ls\n",(const TCHAR*)CString(pArchive->Path));
		pArchive->~Archive();
		bReturn = TRUE;
#ifdef _DEBUG
		BOOL bDoImport = TRUE;
		if (bDoImport) {
			structSmeexOnePatientComm sSmeexImport;
			DoSmeexImport(strFilename,CString(f_strAttachmentDir),&sSmeexImport);
		}
#endif
		//release resources
		pArchive->~Archive();
	}
	//release resources
	pSmeexStructure->~SmeexStructure();
	return bReturn;
}

BOOL CSmeexHandler::DoSmeexImport(const CString &strFilename,
									const CString &strAttachmentDir,
									structSmeexOnePatientComm *psSmeexOnePatientComm)
{
	BOOL bReturn = FALSE;
	if (!psSmeexOnePatientComm) {
		ASSERT(FALSE);
		return bReturn;
	}
	Vsfm::Smeex::Framework::Common::Archive ^pArchive = gcnew Vsfm::Smeex::Framework::Common::Archive(gcnew System::String(strFilename));
	if (!pArchive) {
		ASSERT(FALSE);
		return bReturn;
	}
#ifdef _DEBUG
	if (!strAttachmentDir.IsEmpty()) {
		CFileStatus status;
		ASSERT(CFile::GetStatus(CString(strAttachmentDir),status));
	}
#endif
	f_strAttachmentDir = gcnew System::String(strAttachmentDir);
	f_mapDiagnosisImportParentID.Clear();
	f_mapDiagnosisImportAddedID.Clear();
	f_mapDocumentsImportedID.Clear();
	f_psSmeexOnePatientComm=psSmeexOnePatientComm;
	INIT_SMEEXONEPATIENTCOMMSTRUCT((*psSmeexOnePatientComm));
	psSmeexOnePatientComm->sSmeexArchive.strSmeexID = CString(pArchive->SmeexId);
	psSmeexOnePatientComm->sSmeexArchive.strTemplateSmeexId = CString(pArchive->TemplateSmeexId);
	psSmeexOnePatientComm->sSmeexArchive.strTitle = CString(pArchive->Title);
	psSmeexOnePatientComm->sSmeexArchive.strLanguage = CString(pArchive->Language);
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure = gcnew Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure(pArchive);
	if (!pSmeexStructure) {
		ASSERT(FALSE);
		return bReturn;
	}
	DoImportProcessingInfo(pSmeexStructure);
	//
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure::PatientInfoCollection ^pPatientInfoCollection = pSmeexStructure->PatientInfo;
	int i = 0;
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo in pPatientInfoCollection ) {
		if (!pPatientInfo) {
			ASSERT(FALSE);
			continue;
		}
		i++;
		DoImportPatientInfo(pSmeexStructure,pPatientInfo);
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG = pPatientInfo->Kg;
		if (pKG) {
			DoImportKg(pSmeexStructure,pKG);
		}
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo::DocumentTreeCollection ^pDocumentTreeCollection = pPatientInfo->DocumentTree;
		if (pDocumentTreeCollection) {
			for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree ^pDocumentTree in pDocumentTreeCollection ) {
				if (pDocumentTree) {
					DoImportDocumentTree(pSmeexStructure,pDocumentTree);
				}
			}
		}
	}
	//
	pSmeexStructure->~SmeexStructure();
	pArchive->~Archive();
	//
	bReturn = TRUE;
	return bReturn;
}

void CSmeexHandler::DoExportProcessingInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::GlobalDefinitions ^pGlobalDefinitions = pSmeexStructure->NewGlobalDefinitions();
	if (!pGlobalDefinitions) {
		ASSERT(FALSE);
		return;
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo = pSmeexStructure->NewProcessingInfo();
	if (!pProcessingInfo) {
		ASSERT(FALSE);
		return;
	}
	pProcessingInfo->Date = System::DateTime::FromOADate(f_psSmeexOnePatientComm->sProcessingInfo.dDate);
	pProcessingInfo->Title = gcnew System::String((TCHAR*)f_psSmeexOnePatientComm->sProcessingInfo.strTitle);
	//
	DoExportAuthor(pSmeexStructure,pProcessingInfo);
	//
	DoExportRecipient(pSmeexStructure,pProcessingInfo);
	//
	DoExportSoftware(pSmeexStructure,pProcessingInfo);
}

void CSmeexHandler::DoImportProcessingInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo = pSmeexStructure->ProcessingInfo;
	if (!pProcessingInfo) {
		ASSERT(FALSE);
		return;
	}
	else {
		f_psSmeexOnePatientComm->sProcessingInfo.dDate = pProcessingInfo->Date.ToOADate();
		f_psSmeexOnePatientComm->sProcessingInfo.strTitle = CString(pProcessingInfo->Title);
	}
	DoImportAuthor(pProcessingInfo);
	DoImportRecipient(pProcessingInfo);
	DoImportSoftware(pProcessingInfo);
}

void CSmeexHandler::DoExportAuthor(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
									Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::AuthorAddress ^pAuthorAddress = pProcessingInfo->NewAuthorAddress();
	if (!pAuthorAddress) {
		ASSERT(FALSE);
		return;
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pSmeexStructure->NewAddress();
	if (!pAddress) {
		AfxMessageBox(_T("pAuthorAddress->AddressRefID==NULL"));
		ASSERT(FALSE);
		return;
	}
	//
	DoExportAddress(&f_psSmeexOnePatientComm->sProcessingInfo.sAuthor,pAddress);
	pAuthorAddress->AddressRefID = pAddress;
}

void CSmeexHandler::DoImportAuthor(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::AuthorAddress ^pAuthorAddress = pProcessingInfo->AuthorAddress;
	if (!pAuthorAddress) {
		ASSERT(FALSE);
		return;
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pAuthorAddress->AddressRefID;
	if (!pAddress) {
		AfxMessageBox(_T("pAuthorAddress->AddressRefID==NULL"));
		ASSERT(FALSE);
		return;
	}
	DoImportAddress(pAddress,&f_psSmeexOnePatientComm->sProcessingInfo.sAuthor);
}

void CSmeexHandler::DoExportRecipient(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
										Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::RecipientAddress ^pRecipientAddress = pProcessingInfo->NewRecipientAddress();
	if (!pRecipientAddress) {
		ASSERT(FALSE);
		return;
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pSmeexStructure->NewAddress();
	if (!pAddress) {
		AfxMessageBox(_T("pRecipientAddress->AddressRefID==NULL"));
		ASSERT(FALSE);
		return;
	}
	DoExportAddress(&f_psSmeexOnePatientComm->sProcessingInfo.sRecipient,pAddress);
	pRecipientAddress->AddressRefID = pAddress;
}

void CSmeexHandler::DoImportRecipient(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::RecipientAddress ^pRecipientAddress = pProcessingInfo->RecipientAddress;
	if (!pRecipientAddress) {
		ASSERT(FALSE);
		return;
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pRecipientAddress->AddressRefID;
	if (!pAddress) {
		AfxMessageBox(_T("pRecipientAddress->AddressRefID==NULL"));
		ASSERT(FALSE);
		return;
	}
	DoImportAddress(pAddress,&f_psSmeexOnePatientComm->sProcessingInfo.sRecipient);
}

void CSmeexHandler::DoExportSoftware(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
										Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Software ^pSoftware = pProcessingInfo->NewSoftware();
	if (!pSoftware) {
		ASSERT(FALSE);
		return;
	}
	structSmeexSoftware *psSoftware = &f_psSmeexOnePatientComm->sProcessingInfo.sSoftware;
	pSoftware->Name = gcnew System::String((TCHAR*)psSoftware->strName);
	pSoftware->Version = gcnew System::String((TCHAR*)psSoftware->strVersion);
	pSoftware->Copyright = gcnew System::String((TCHAR*)psSoftware->strCopyright);

	if (psSoftware->sManufacturer.strLastName.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ManufacturerAddress ^pManufacturerAddress = pSoftware->NewManufacturerAddress();
		if (!pManufacturerAddress) {
			ASSERT(FALSE);
			return;
		}
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pSmeexStructure->NewAddress();
		if (!pAddress) {
			AfxMessageBox(_T("pManufacturerAddress->AddressRefID==NULL"));
			ASSERT(FALSE);
			return;
		}
		DoExportAddress(&psSoftware->sManufacturer,pAddress);
		pManufacturerAddress->AddressRefID = pAddress;
	}
}

void CSmeexHandler::DoImportSoftware(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProcessingInfo ^pProcessingInfo)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Software ^pSoftware = pProcessingInfo->Software;
	if (!pSoftware) {
		ASSERT(FALSE);
		return;
	}
	structSmeexSoftware *psSoftware = &f_psSmeexOnePatientComm->sProcessingInfo.sSoftware;
	psSoftware->strName = CString(pSoftware->Name);
	psSoftware->strVersion = CString(pSoftware->Version);
	psSoftware->strCopyright = CString(pSoftware->Copyright);
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ManufacturerAddress ^pManufacturerAddress = pSoftware->ManufacturerAddress;
	if (pManufacturerAddress) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pManufacturerAddress->AddressRefID;
		if (pAddress) {
			DoImportAddress(pAddress,&f_psSmeexOnePatientComm->sProcessingInfo.sSoftware.sManufacturer);
		}
	}
	TRACE("Software: '%s' '%s'\n",pSoftware->Name,pSoftware->Version);
}

void CSmeexHandler::DoExportAddress(const structSmeexAddress *psAddress,Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress)
{
	if (!pAddress) {
		ASSERT(FALSE);
		return;
	}
	pAddress->ID = psAddress->lID;
	//
	if (psAddress->eSmeexAddressType!=eCompanySmeexAddressType) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Person ^pPerson = pAddress->NewPerson();
		if (!pPerson) {
			ASSERT(FALSE);
			return;
		}
		pPerson->Familyname = gcnew System::String((TCHAR*)psAddress->strLastName);
		pPerson->Firstname = gcnew System::String((TCHAR*)psAddress->strFirstName);
		pPerson->Maidenname = gcnew System::String((TCHAR*)psAddress->strMaidenname);
		pPerson->Salutation = gcnew System::String((TCHAR*)psAddress->strSalutation);
		pPerson->Sex = psAddress->eSex;
		if (psAddress->strSpecialty1.length()) {
			System::String ^pSpecialty = gcnew System::String((TCHAR*)psAddress->strSpecialty1);
			pPerson->Specialty->Add(pSpecialty);
		}
		if (psAddress->strSpecialty2.length()) {
			System::String ^pSpecialty = gcnew System::String((TCHAR*)psAddress->strSpecialty2);
			pPerson->Specialty->Add(pSpecialty);
		}
		pPerson->Subaddress = gcnew System::String((TCHAR*)psAddress->strSubaddress);
		pPerson->Title = gcnew System::String((TCHAR*)psAddress->strTitle);
	}
	else {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Company ^pCompany = pAddress->NewCompany();
		if (!pCompany) {
			ASSERT(FALSE);
			return;
		}
#pragma message("INFO: notimplemented Address::Company ContactPersonPtr")
		//pCompany->ContactPersonPtr = ;
		pCompany->Department = gcnew System::String((TCHAR*)psAddress->strFirstName);
		pCompany->Name = gcnew System::String((TCHAR*)psAddress->strLastName);
		pCompany->Subaddress = gcnew System::String((TCHAR*)psAddress->strSubaddress);
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Postal ^pPostal = pAddress->NewPostal();
	if (!pPostal) {
		ASSERT(FALSE);
		return;
	}
	pPostal->Pobox = gcnew System::String((TCHAR*)psAddress->strPoBox);
	pPostal->Street = gcnew System::String((TCHAR*)psAddress->strStreet);
	pPostal->Zip = gcnew System::String((TCHAR*)psAddress->strZip);
	pPostal->City = gcnew System::String((TCHAR*)psAddress->strCity);
	pPostal->Canton = gcnew System::String((TCHAR*)psAddress->strCanton);
	pPostal->Country = gcnew System::String((TCHAR*)psAddress->strCountry);
	//
	BOOL bAddTelecom = FALSE;
	if (psAddress->strPhoneHome.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom = pAddress->NewTelecom();
		if (!pTelecom) {
			ASSERT(FALSE);
			return;
		}
		pTelecom->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtHome;
		pTelecom->PhoneType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Phone;
		pTelecom->PhoneNumber = gcnew System::String((TCHAR*)psAddress->strPhoneHome);
	}
	if (psAddress->strPhoneOffice.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom = pAddress->NewTelecom();
		if (!pTelecom) {
			ASSERT(FALSE);
			return;
		}
		pTelecom->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtOffice;
		pTelecom->PhoneType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Phone;
		pTelecom->PhoneNumber = gcnew System::String((TCHAR*)psAddress->strPhoneOffice);
	}
	if (psAddress->strNatelHome.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom = pAddress->NewTelecom();
		if (!pTelecom) {
			ASSERT(FALSE);
			return;
		}
		pTelecom->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtHome;
		pTelecom->PhoneType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Cellular;
		pTelecom->PhoneNumber = gcnew System::String((TCHAR*)psAddress->strNatelHome);
	}
	if (psAddress->strNatelOffice.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom = pAddress->NewTelecom();
		if (!pTelecom) {
			ASSERT(FALSE);
			return;
		}
		pTelecom->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtOffice;
		pTelecom->PhoneType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Cellular;
		pTelecom->PhoneNumber = gcnew System::String((TCHAR*)psAddress->strNatelOffice);
	}
	if (psAddress->strFaxHome.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom = pAddress->NewTelecom();
		if (!pTelecom) {
			ASSERT(FALSE);
			return;
		}
		pTelecom->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtHome;
		pTelecom->PhoneType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Fax;
		pTelecom->PhoneNumber = gcnew System::String((TCHAR*)psAddress->strFaxHome);
	}
	if (psAddress->strFaxOffice.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom = pAddress->NewTelecom();
		if (!pTelecom) {
			ASSERT(FALSE);
			return;
		}
		pTelecom->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtOffice;
		pTelecom->PhoneType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Fax;
		pTelecom->PhoneNumber = gcnew System::String((TCHAR*)psAddress->strFaxOffice);
	}
	//Online
	if (psAddress->strMailHome.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online ^pOnline = pAddress->NewOnline();
		if (!pOnline) {
			ASSERT(FALSE);
			return;
		}
		pOnline->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOriginType::AtHome;
		pOnline->OnlineType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOnlineType::Email;
		pOnline->OnlineAddress = gcnew System::String((TCHAR*)psAddress->strMailHome);
	}
	if (psAddress->strMailOffice.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online ^pOnline = pAddress->NewOnline();
		if (!pOnline) {
			ASSERT(FALSE);
			return;
		}
		pOnline->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOriginType::AtOffice;
		pOnline->OnlineType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOnlineType::Email;
		pOnline->OnlineAddress = gcnew System::String((TCHAR*)psAddress->strMailOffice);
	}
	if (psAddress->strUrlHome.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online ^pOnline = pAddress->NewOnline();
		if (!pOnline) {
			ASSERT(FALSE);
			return;
		}
		pOnline->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOriginType::AtHome;
		pOnline->OnlineType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOnlineType::Uri;
		pOnline->OnlineAddress = gcnew System::String((TCHAR*)psAddress->strUrlHome);
	}
	if (psAddress->strUrlOffice.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online ^pOnline = pAddress->NewOnline();
		if (!pOnline) {
			ASSERT(FALSE);
			return;
		}
		pOnline->OriginType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOriginType::AtOffice;
		pOnline->OnlineType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOnlineType::Uri;
		pOnline->OnlineAddress = gcnew System::String((TCHAR*)psAddress->strUrlOffice);
	}
	//Identificators
	if (psAddress->strEAN.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators ^pIdentificator = pAddress->NewIdentificators();
		if (!pIdentificator) {
			ASSERT(FALSE);
			return;
		}
		pIdentificator->IdentificatorType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::EAN;
		pIdentificator->Identificator = gcnew System::String((TCHAR*)psAddress->strEAN);
	}
	if (psAddress->strNIF.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators ^pIdentificator = pAddress->NewIdentificators();
		if (!pIdentificator) {
			ASSERT(FALSE);
			return;
		}
		pIdentificator->IdentificatorType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::NIF;
		pIdentificator->Identificator = gcnew System::String((TCHAR*)psAddress->strNIF);
	}
	if (psAddress->strZSR.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators ^pIdentificator = pAddress->NewIdentificators();
		if (!pIdentificator) {
			ASSERT(FALSE);
			return;
		}
		pIdentificator->IdentificatorType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::ZSR;
		pIdentificator->Identificator = gcnew System::String((TCHAR*)psAddress->strZSR);
	}
	if (psAddress->strRegNumber.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators ^pIdentificator = pAddress->NewIdentificators();
		if (!pIdentificator) {
			ASSERT(FALSE);
			return;
		}
		pIdentificator->IdentificatorType = Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::RegNumber;
		pIdentificator->Identificator = gcnew System::String((TCHAR*)psAddress->strRegNumber);
	}
}

void CSmeexHandler::DoImportAddress(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress,
	structSmeexAddress *psAddress)
{
	if (!pAddress) {
		ASSERT(FALSE);
		return;
	}
#ifdef _DEBUG
	DoTraceAddress(pAddress);
#endif
	psAddress->lID = (long)pAddress->ID;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Person ^pPerson = pAddress->Person;
	if (!pPerson) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Company ^pCompany = pAddress->Company;
		if (!pCompany) {
			ASSERT(FALSE);
			return;
		}
		psAddress->eSmeexAddressType = eCompanySmeexAddressType;
		//pCompany->ContactPersonPtr = ;
		psAddress->strFirstName = CString(pCompany->Department);
		psAddress->strLastName = CString(pCompany->Name);
		psAddress->strSubaddress = CString(pCompany->Subaddress);
	}
	else {
		psAddress->eSmeexAddressType = ePersonSmeexAddressType;
		psAddress->eSex = pPerson->Sex;
		psAddress->strLastName = CString(pPerson->Familyname);
		psAddress->strFirstName = CString(pPerson->Firstname);
		psAddress->strMaidenname = CString(pPerson->Maidenname);
		psAddress->strSalutation = CString(pPerson->Salutation);
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Person::SpecialtyCollection ^pSpecialtyCollection = pPerson->Specialty;
		int i = 0;
		for each ( System::String ^pString in pSpecialtyCollection ) {
			i++;
			if (!pString) {
				ASSERT(FALSE);
				continue;
			}
			switch (i)
			{
				case 1:
					psAddress->strSpecialty1 = CString(pString);
					break;
				case 2:
					psAddress->strSpecialty2 = CString(pString);
					break;
				default:
#pragma message("NOTE: only two Specialty supported")
					break;
			}
		}
		psAddress->strSubaddress = CString(pPerson->Subaddress);
		psAddress->strTitle = CString(pPerson->Title);
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Postal ^pPostal = pAddress->Postal;
	if (pPostal) {
		psAddress->strPoBox = CString(pPostal->Pobox);
		psAddress->strStreet = CString(pPostal->Street);
		psAddress->strZip = CString(pPostal->Zip);
		psAddress->strCity = CString(pPostal->City);
		psAddress->strCanton = CString(pPostal->Canton);
		psAddress->strCountry = CString(pPostal->Country);
	}
	//telecom
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address::TelecomCollection ^pTelecomCollection = pAddress->Telecom;
	int i = 0;
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom ^pTelecom in pTelecomCollection ) {
		ASSERT(pTelecom);
		i++;
		BOOL bAtHome = FALSE;
		BOOL bAtOffice = FALSE;
		switch (pTelecom->OriginType)
		{
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtOffice:
				bAtOffice = TRUE;
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumOriginType::AtHome:
				bAtHome = TRUE;
				break;
			default:
				ASSERT(FALSE);
				break;
		}
		switch (pTelecom->PhoneType)
		{
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Phone:
				if (bAtHome) {
					ASSERT(psAddress->strPhoneHome.length()==0);
					if (psAddress->strPhoneHome.length()==0) {
						psAddress->strPhoneHome = CString(pTelecom->PhoneNumber);
					}
				}
				else if (bAtOffice) {
					ASSERT(psAddress->strPhoneOffice.length()==0);
					if (psAddress->strPhoneOffice.length()==0) {
						psAddress->strPhoneOffice = CString(pTelecom->PhoneNumber);
					}
				}
				else {
					ASSERT(FALSE);
				}
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Cellular:
				if (bAtHome) {
					ASSERT(psAddress->strNatelHome.length()==0);
					if (psAddress->strNatelHome.length()==0) {
						psAddress->strNatelHome = CString(pTelecom->PhoneNumber);
					}
				}
				else if (bAtOffice) {
					ASSERT(psAddress->strNatelOffice.length()==0);
					if (psAddress->strNatelOffice.length()==0) {
						psAddress->strNatelOffice = CString(pTelecom->PhoneNumber);
					}
				}
				else {
					ASSERT(FALSE);
				}
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Telecom::EnumPhoneType::Fax:
				if (bAtHome) {
					ASSERT(psAddress->strFaxHome.length()==0);
					if (psAddress->strFaxHome.length()==0) {
						psAddress->strFaxHome = CString(pTelecom->PhoneNumber);
					}
				}
				else if (bAtOffice) {
					ASSERT(psAddress->strFaxOffice.length()==0);
					if (psAddress->strFaxOffice.length()==0) {
						psAddress->strFaxOffice = CString(pTelecom->PhoneNumber);
					}
				}
				else {
					ASSERT(FALSE);
				}
				break;
			default:
				ASSERT(FALSE);
				break;
		}
	}
	//Online
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address::OnlineCollection ^pOnlineCollection = pAddress->Online;
	i = 0;
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online ^pOnline in pOnlineCollection ) {
		ASSERT(pOnline);
		i++;
		BOOL bAtHome = FALSE;
		BOOL bAtOffice = FALSE;
		switch (pOnline->OriginType)
		{
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOriginType::AtOffice:
				bAtOffice = TRUE;
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOriginType::AtHome:
				bAtHome = TRUE;
				break;
			default:
				ASSERT(FALSE);
				break;
		}
		switch (pOnline->OnlineType)
		{
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOnlineType::Email:
				if (bAtHome) {
					ASSERT(psAddress->strMailHome.length()==0);
					if (psAddress->strMailHome.length()==0) {
						psAddress->strMailHome = CString(pOnline->OnlineAddress);
					}
				}
				else if (bAtOffice) {
					ASSERT(psAddress->strMailOffice.length()==0);
					if (psAddress->strMailOffice.length()==0) {
						psAddress->strMailOffice = CString(pOnline->OnlineAddress);
					}
				}
				else {
					ASSERT(FALSE);
				}
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Online::EnumOnlineType::Uri:
				if (bAtHome) {
					ASSERT(psAddress->strUrlHome.length()==0);
					if (psAddress->strUrlHome.length()==0) {
						psAddress->strUrlHome = CString(pOnline->OnlineAddress);
					}
				}
				else if (bAtOffice) {
					ASSERT(psAddress->strUrlOffice.length()==0);
					if (psAddress->strUrlOffice.length()==0) {
						psAddress->strUrlOffice = CString(pOnline->OnlineAddress);
					}
				}
				else {
					ASSERT(FALSE);
				}
				break;
			default:
				ASSERT(FALSE);
				break;
		}
	}
	//Identificators
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address::IdentificatorsCollection ^pIdentificatorsCollection = pAddress->Identificators;
	i = 0;
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators ^pIdentificator in pIdentificatorsCollection ) {
		ASSERT(pIdentificator);
		i++;
		switch (pIdentificator->IdentificatorType)
		{
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::EAN:
				ASSERT(psAddress->strEAN.length()==0);
				if (psAddress->strEAN.length()==0) {
					psAddress->strEAN = CString(pIdentificator->Identificator);
				}
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::NIF:
				ASSERT(psAddress->strNIF.length()==0);
				if (psAddress->strNIF.length()==0) {
					psAddress->strNIF = CString(pIdentificator->Identificator);
				}
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::ZSR:
				ASSERT(psAddress->strZSR.length()==0);
				if (psAddress->strZSR.length()==0) {
					psAddress->strZSR = CString(pIdentificator->Identificator);
				}
				break;
			case Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Identificators::EnumIdentificatorType::RegNumber:
				ASSERT(psAddress->strRegNumber.length()==0);
				if (psAddress->strRegNumber.length()==0) {
					psAddress->strRegNumber = CString(pIdentificator->Identificator);
				}
				break;
			default:
				ASSERT(FALSE);
				break;
		}
	}
}

#ifdef _DEBUG
void CSmeexHandler::DoTraceAddress(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress)
{
	if (!pAddress) {
		ASSERT(FALSE);
		return;
	}
	BOOL bIsCompany = FALSE;
	BOOL bIsPerson = FALSE;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Company ^pCompany = pAddress->Company;
	if (pCompany && !CString(pCompany->Name).IsEmpty()) {
		bIsCompany = TRUE;
		TRACE("'%s' '%s'\n",pCompany->Name,pCompany->Department);
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Person ^pPerson = pAddress->Person;
	if (pPerson && !CString(pPerson->Familyname).IsEmpty()) {
		bIsPerson = TRUE;
		TRACE("'%s' '%s'\n",pPerson->Familyname,pPerson->Firstname);
	}
	ASSERT(bIsCompany!=bIsPerson);
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Postal ^pPostal = pAddress->Postal;
	if (pPostal) {
		TRACE("'%s' '%s'\n",pPostal->Zip,pPostal->City);
	}
}
#endif

void CSmeexHandler::DoExportPatientInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
					Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo)
{
	long lDummyID = 0;
	structSmeexPatientAddress *psPatientInfo = &f_psSmeexOnePatientComm->sPatientInfo.sPatient;
	pPatientInfo->ID = f_psSmeexOnePatientComm->sPatientInfo.lID;
	//
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress ^pPatientAddress = pPatientInfo->NewPatientAddress();
	if (!pPatientAddress) {
		ASSERT(FALSE);
		return;
	}
	pPatientAddress->PatientID = psPatientInfo->lPatientID;
	pPatientAddress->StatusType = psPatientInfo->eStatusType;
	pPatientAddress->BirthDate = System::DateTime::FromOADate(psPatientInfo->dBirthdate);
	pPatientAddress->Ssn = gcnew System::String((TCHAR*)psPatientInfo->strSsn);
	pPatientAddress->Profession = gcnew System::String((TCHAR*)psPatientInfo->strProfession);
	pPatientAddress->Nationality = gcnew System::String((TCHAR*)psPatientInfo->strNationality);
	pPatientAddress->Denomination = gcnew System::String((TCHAR*)psPatientInfo->strDenomination);
	pPatientAddress->HmoAffiliation = gcnew System::String((TCHAR*)psPatientInfo->strHmoAffiliation);
	pPatientAddress->Language = gcnew System::String((TCHAR*)psPatientInfo->strNationalLanguage);
	pPatientAddress->Ethnicity = psPatientInfo->eEthnicity;
	pPatientAddress->MaritalStatus = psPatientInfo->eMaritalStatus;

	ASSERT(psPatientInfo->sAddress.strLastName.length());
	if (psPatientInfo->sAddress.strLastName.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pSmeexStructure->NewAddress();
		if (!pAddress) {
			AfxMessageBox(_T("pPatientAddress->AddressRefID==NULL"));
			ASSERT(FALSE);
			return;
		}
		DoExportAddress(&psPatientInfo->sAddress,pAddress);
		pPatientAddress->AddressRefID = pAddress;
	}
}

void CSmeexHandler::DoImportPatientInfo(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
					Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo)
{
	f_psSmeexOnePatientComm->sPatientInfo.lID = (long)pPatientInfo->ID;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientAddress ^pPatientAddress = pPatientInfo->PatientAddress;
	if (!pPatientAddress) {
		ASSERT(FALSE);
		return;
	}
	structSmeexPatientAddress *psPatientInfo = &f_psSmeexOnePatientComm->sPatientInfo.sPatient;
	psPatientInfo->lPatientID = pPatientAddress->PatientID;
	psPatientInfo->eStatusType = pPatientAddress->StatusType;
	System::Nullable<System::DateTime> Birthdate = pPatientAddress->BirthDate;
	if (Birthdate.HasValue) {
		psPatientInfo->dBirthdate = pPatientAddress->BirthDate.Value.ToOADate();
	}
	psPatientInfo->strSsn = CString(pPatientAddress->Ssn);
	psPatientInfo->strProfession = CString(pPatientAddress->Profession);
	psPatientInfo->strNationality = CString(pPatientAddress->Nationality);
	psPatientInfo->strDenomination = CString(pPatientAddress->Denomination);
	psPatientInfo->strHmoAffiliation = CString(pPatientAddress->HmoAffiliation);
	psPatientInfo->strNationalLanguage = CString(pPatientAddress->Language);
	psPatientInfo->eEthnicity = pPatientAddress->Ethnicity;
	psPatientInfo->eMaritalStatus = pPatientAddress->MaritalStatus;
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pPatientAddress->AddressRefID;
	if (!pAddress) {
		AfxMessageBox(_T("pPatientAddress->AddressRefID==NULL"));
		ASSERT(FALSE);
		return;
	}
	if (pAddress) {
		DoImportAddress(pAddress,&f_psSmeexOnePatientComm->sPatientInfo.sPatient.sAddress);
	}
	#ifdef _DEBUG
		DoTraceAddress(pPatientAddress->AddressRefID);
	#endif
}

void CSmeexHandler::DoExportKg(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG)
{
	if (!pKG) {
		ASSERT(FALSE);
		return;
	}
	DoExportDiagnosis(pSmeexStructure,pKG);
	DoExportMedication(pSmeexStructure,pKG);
}

void CSmeexHandler::DoImportKg(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG)
{
	if (!pKG) {
		ASSERT(FALSE);
		return;
	}
	DoImportMedication(pSmeexStructure,pKG);
	DoImportDiagnosis(pSmeexStructure,pKG);
}

void CSmeexHandler::DoExportDocumentTree(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
							Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::PatientInfo ^pPatientInfo)
{
	SmeexDocumentTreeArray *parDocumentTree = &f_psSmeexOnePatientComm->sPatientInfo.arDocumentTree;
	SmeexDocumentTreeArray::const_iterator psDocumentTree;
	for(psDocumentTree=parDocumentTree->begin();psDocumentTree!=parDocumentTree->end();psDocumentTree++) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree ^pDocumentTree = pPatientInfo->NewDocumentTree();
		if (!pDocumentTree) {
			ASSERT(FALSE);
			//return;
		}
		pDocumentTree->Name = gcnew System::String((TCHAR*)psDocumentTree->strName);
		//
		SmeexDocumentLeafMap::const_iterator iter;
		for(iter = psDocumentTree->mapDocumentLeaf.begin(); iter != psDocumentTree->mapDocumentLeaf.end(); ++iter) {
			long lChildID = iter->first;
			const SmeexDocumentLeafArray *parDocumentLeaf = &iter->second;
			SmeexDocumentLeafArray::const_iterator psDocumentLeaf;
			for(psDocumentLeaf=parDocumentLeaf->begin();psDocumentLeaf!=parDocumentLeaf->end();psDocumentLeaf++) {
				Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Document ^ pDocument;
				//
				if (!f_mapDocument.TryGetValue(psDocumentLeaf->sSmeexDocument.lID, pDocument)) {
					DoExportDocument(pSmeexStructure,&psDocumentLeaf->sSmeexDocument);
				}
				if (!f_mapDocument.TryGetValue(psDocumentLeaf->sSmeexDocument.lID, pDocument)) {
					ASSERT(FALSE);
					continue;
				}
				Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentLeaf ^pDocumentLeaf = pDocumentTree->NewDocumentLeaf();
				if (!pDocumentLeaf) {
					ASSERT(FALSE);
					return;
				}
				pDocumentLeaf->Name = gcnew System::String((TCHAR*)psDocumentLeaf->strName);
				pDocumentLeaf->Date = System::DateTime::FromOADate(psDocumentLeaf->dDate);
				pDocumentLeaf->Comment = gcnew System::String((TCHAR*)psDocumentLeaf->strComment);
				pDocumentLeaf->DocumentRefID = pDocument;
			}
		}
	}
}

void CSmeexHandler::DoImportDocumentTree(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree ^pDocumentTree)
{
	if (!pDocumentTree) {
		ASSERT(FALSE);
		return;
	}
	TRACE("%ls\n",CString(pDocumentTree->Name));
	SmeexDocumentLeafArray arLeaf;
	structSmeexDocumentTree s;
	INIT_SMEEXDOCUMENTTREESTRUCT(s);
	s.lDocumentTreeChildID = 0;
	s.strName = CString(pDocumentTree->Name);
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree::DocumentLeafCollection ^pDocumentLeafCollection = pDocumentTree->DocumentLeaf;
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentLeaf ^pDocumentLeaf in pDocumentLeafCollection ) {
		if (pDocumentLeaf) {
			Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Document ^pDocument = pDocumentLeaf->DocumentRefID;
			if (pDocument) {
				TRACE("...%ls (%d)\n",CString(pDocumentLeaf->Name),pDocument->ID);
				structSmeexDocumentLeaf sLeaf;
				INIT_SMEEXDOCUMENTLEAFSTRUCT(sLeaf);
				sLeaf.strComment = CString(pDocumentLeaf->Comment);
				sLeaf.dDate = pDocumentLeaf->Date.Value.ToOADate();
				sLeaf.strName = CString(pDocumentLeaf->Name);
				DoImportDocument(pDocument,sLeaf.sSmeexDocument);
				arLeaf.push_back(sLeaf);
			}
		}
	}
	if (arLeaf.size()) {
		s.mapDocumentLeaf[1] = arLeaf;
		f_psSmeexOnePatientComm->sPatientInfo.arDocumentTree.push_back(s);
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree::DocumentTreePtrCollection ^pDocumentTreePtrCollection = pDocumentTree->DocumentTreePtr;
	if (pDocumentTreePtrCollection) {
		for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::DocumentTree ^pSubDocumentTree in pDocumentTreePtrCollection ) {
			if (pSubDocumentTree) {
				ASSERT(FALSE);
				TRACE("->%ls\n",CString(pSubDocumentTree->Name));
			}
		}
	}
}

void CSmeexHandler::DoExportDocument(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
			const structSmeexDocument *psDocument)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Document ^pDocument = pSmeexStructure->NewDocument();
	if (!pDocument) {
		ASSERT(FALSE);
		return;
	}
	CString strFilename = psDocument->strFilepath;
	strFilename.Replace('/','\\');
	long lPos = strFilename.ReverseFind('\\');
	if (lPos!=-1) {
		strFilename = strFilename.Mid(lPos+1);
	}
	//pDocument->Filename = gcnew System::String(strFilename);
	pDocument->ID = psDocument->lID;
	//pDocument->MimeType = gcnew System::String((TCHAR*)psDocument->strMimeType);
	//pDocument->Size = psDocument->lSize;
	pDocument->ImportFile(gcnew System::String((TCHAR*)psDocument->strFilepath));
#ifdef _DEBUG
	strFilename = CString(pDocument->Filename);
	CString strMimeType = CString(pDocument->MimeType);
	long lSize = pDocument->Size;
#endif
	if (psDocument->sProducerAddress.strLastName.length()) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProducerAddress_Document ^pProducerAddress = pDocument->NewProducerAddress();
		if (!pProducerAddress) {
			ASSERT(FALSE);
			return;
		}
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pSmeexStructure->NewAddress();
		//pRecipientAddress->AddressRefID = pAddress;
		//Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pRecipientAddress->AddressRefID;
		if (!pAddress) {
			AfxMessageBox(_T("pProducerAddress->AddressRefID==NULL"));
			ASSERT(FALSE);
			return;
		}
		DoExportAddress(&psDocument->sProducerAddress,pAddress);
		pProducerAddress->AddressRefID = pAddress;
	}
	f_mapDocument.Add(psDocument->lID,pDocument);
}

void CSmeexHandler::DoImportDocument(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Document ^pDocument,
			structSmeexDocument &s)
{
	INIT_SMEEXDOCUMENTSTRUCT(s);
	long lID = (long)pDocument->ID;
	long lValue;
    if (f_mapDocumentsImportedID.TryGetValue(lID, lValue)) {
		ASSERT(FALSE);
		return;
    }
	CString strFilepath;
	strFilepath = CString(f_strAttachmentDir);
	BOOL bHasAttachmentDir = (strFilepath.IsEmpty()) ? FALSE : TRUE;
	if (bHasAttachmentDir) {
		if (strFilepath.Right(1)!=_T("\\")) {
			strFilepath += _T("\\");
		}
	}
	strFilepath += CString(pDocument->Filename);
	s.strFilepath = strFilepath;
	if (bHasAttachmentDir) {
		try {
			CFile::Remove(s.strFilepath);
		}
		catch(...) {
		}
		pDocument->ExportFile(gcnew System::String((TCHAR*)s.strFilepath));
	}
	s.lID = (long)pDocument->ID;
	s.strMimeType = CString(pDocument->MimeType);
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::ProducerAddress_Document ^pProducerAddress = pDocument->ProducerAddress;
	if (pProducerAddress) {
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Address ^pAddress = pProducerAddress->AddressRefID;
		if (pAddress) {
			DoImportAddress(pAddress,&s.sProducerAddress);
		}
	}
	s.lSize = pDocument->Size;
	TRACE("...%ls %d\n",CString((TCHAR*)s.strFilepath),s.lID);
	f_mapDocumentsImportedID[s.lID] = s.lID;
}

void CSmeexHandler::DoExportMedication(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG)
{
	SmeexMedicationArray *parMedication = &f_psSmeexOnePatientComm->sPatientInfo.sKg.arMedication;
	if (parMedication==NULL||parMedication->size()==0) {
		ASSERT(parMedication);
		return;
	}
	SmeexMedicationArray::const_iterator psMedication;
	for(psMedication=parMedication->begin();psMedication!=parMedication->end();psMedication++) {
		System::String ^strKey = gcnew System::String(BuildCodingEntryKey(psMedication->strCodingEntryCode,psMedication->strCodingEntryName));
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::CodingEntry ^ pCodingEntry;
        if (f_mapCodingEntry.TryGetValue(strKey, pCodingEntry)) {
        }
        else {
			Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::GlobalDefinitions ^pGlobalDefinitions = pSmeexStructure->NewGlobalDefinitions();
			if (!pGlobalDefinitions) {
				ASSERT(FALSE);
				return;
			}
			pCodingEntry = pGlobalDefinitions->NewCodingEntry();
			if (!pCodingEntry) {
				ASSERT(FALSE);
				return;
			}
			pCodingEntry->Code = gcnew System::String((TCHAR*)psMedication->strCodingEntryCode);
			pCodingEntry->Name = gcnew System::String((TCHAR*)psMedication->strCodingEntryName);
			f_mapCodingEntry.Add(strKey, pCodingEntry);
        }
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication ^pMedication = pKG->NewMedication();
		if (!pMedication) {
			ASSERT(FALSE);
			return;
		}
		pMedication->CodingEntryPtr = pCodingEntry;
		pMedication->CodingType = psMedication->eCodingType;
		pMedication->Date = System::DateTime::FromOADate(psMedication->dDate);
#pragma message("INFO: notimplemented Medication::DocumentRefID")
		//psMedication->lDocumentRefID;
		pMedication->ID = psMedication->lID;
		if (psMedication->bIsActive!=-1) {
			pMedication->IsActive = (psMedication->bIsActive) ? true : false;
		}
		if (psMedication->bIsChronic!=-1) {
			pMedication->IsChronic = (psMedication->bIsChronic) ? true : false;
		}
		pMedication->Name = gcnew System::String((TCHAR*)psMedication->strName);
		pMedication->ShortName = gcnew System::String((TCHAR*)psMedication->strShortName);
		//
		SmeexPosologyArray::const_iterator psPosology;
		for(psPosology=psMedication->arPosology.begin();psPosology!=psMedication->arPosology.end();psPosology++) {
			BOOL bHasPosology = IsValidDate(psPosology->dDateBegin);
			ASSERT(bHasPosology);
			if (bHasPosology) {
				Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Posology ^pPosology = pMedication->NewPosology();
				if (!pPosology) {
					ASSERT(FALSE);
					return;
				}
				pPosology->DateBegin = System::DateTime::FromOADate(psPosology->dDateBegin);
				if (IsValidDate(psPosology->dDateEnd)) {
					pPosology->DateEnd = System::DateTime::FromOADate(psPosology->dDateEnd);
				}
	#pragma message("INFO: notimplemented Posology::DocumentRefID")
				//psPosology->lDocumentRefID;
				pPosology->QuantityMorning = psPosology->dQuantityMorning;
				pPosology->QuantityNoon = psPosology->dQuantityNoon;
				pPosology->QuantityEvening = psPosology->dQuantityEvening;
				pPosology->QuantityNight = psPosology->dQuantityNight;
				pPosology->Remark = gcnew System::String((TCHAR*)psPosology->strRemark);
			}
		}
	}
}

void CSmeexHandler::DoImportMedication(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg::MedicationCollection ^pMedicationCollection = pKG->Medication;
	if (!pMedicationCollection) {
		ASSERT(FALSE);
		return;
	}
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication ^pMedication in pMedicationCollection ) {
		if (!pMedication) {
			ASSERT(FALSE);
			continue;
		}
		structSmeexMedication sMedication;
		INIT_SMEEXMEDICATIONSTRUCT(sMedication);
		//
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::CodingEntry ^pCodingEntry = pMedication->CodingEntryPtr;
		if (!pCodingEntry) {
			ASSERT(FALSE);
			//return;
		}
		else {
			sMedication.strCodingEntryCode = CString(pCodingEntry->Code);
			sMedication.strCodingEntryName = CString(pCodingEntry->Name);
		}
		sMedication.eCodingType = pMedication->CodingType;
		System::Nullable<System::DateTime> DateValue = pMedication->Date;
		if (DateValue.HasValue) {
			sMedication.dDate = pMedication->Date.Value.ToOADate();
		}
#pragma message("INFO: notimplemented Medication::DocumentRefID")
		//sMedication.lDocumentRefID = pMedication->DocumentRefID;
		sMedication.lID = (long)pMedication->ID;
		System::Nullable<bool> BoolValue;
		BoolValue = pMedication->IsActive;
		if (BoolValue.HasValue) {
			sMedication.bIsActive = (pMedication->IsActive.Value==true) ? TRUE : FALSE;
		}
		BoolValue = pMedication->IsChronic;
		if (BoolValue.HasValue) {
			sMedication.bIsChronic = (pMedication->IsChronic.Value==true) ? TRUE : FALSE;
		}
		sMedication.strName = CString(pMedication->Name);
		sMedication.strShortName = CString(pMedication->ShortName);
		//
		Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Medication::PosologyCollection ^pPosologyCollection = pMedication->Posology;
		if (pPosologyCollection) {
			for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Posology ^pPosology in pPosologyCollection ) {
				structSmeexPosology sPosology;
				INIT_SMEEXPOSOLOGYSTRUCT(sPosology);
				sPosology.dDateBegin = pPosology->DateBegin.ToOADate();
				System::Nullable<System::DateTime> DateEnd = pPosology->DateEnd;
				if (DateEnd.HasValue) {
					sPosology.dDateEnd = pPosology->DateEnd.Value.ToOADate();
				}
#pragma message("INFO: notimplemented Posology::DocumentRefID")
				//sMedication.lPosologyDocumentRefID = pPosology->DocumentRefID;
				System::Nullable<double> Value;
				Value = pPosology->QuantityMorning;
				if (Value.HasValue) {
					sPosology.dQuantityMorning = pPosology->QuantityMorning.Value;
				}
				Value = pPosology->QuantityNoon;
				if (Value.HasValue) {
					sPosology.dQuantityNoon = pPosology->QuantityNoon.Value;
				}
				Value = pPosology->QuantityEvening;
				if (Value.HasValue) {
					sPosology.dQuantityEvening = pPosology->QuantityEvening.Value;
				}
				Value = pPosology->QuantityNight;
				if (Value.HasValue) {
					sPosology.dQuantityNight = pPosology->QuantityNight.Value;
				}
				sPosology.strRemark = CString(pPosology->Remark);
				sMedication.arPosology.push_back(sPosology);
			}
		}
		if (sMedication.arPosology.size()==0) {
			structSmeexPosology sPosology;
			INIT_SMEEXPOSOLOGYSTRUCT(sPosology);
			sMedication.arPosology.push_back(sPosology);
		}
		f_psSmeexOnePatientComm->sPatientInfo.sKg.arMedication.push_back(sMedication);
	}
}

void CSmeexHandler::DoExportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG)
{
	SmeexDiagnosisMap *pmapDiagnosis = &f_psSmeexOnePatientComm->sPatientInfo.sKg.mapDiagnosis;
	if (pmapDiagnosis==NULL||pmapDiagnosis->size()==0) {
		ASSERT(pmapDiagnosis);
		return;
	}
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::DiagnosisPtrCollection ^pDiagnosisCollection;
	long lParentID = 0;
	DoRawExportDiagnosis(pSmeexStructure,pKG,lParentID,pDiagnosisCollection);
}

void CSmeexHandler::DoImportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG)
{
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg::DiagnosisCollection ^pDiagnosisCollection = pKG->Diagnosis;
	if (!pDiagnosisCollection) {
		ASSERT(FALSE);
		return;
	}
	for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis ^pDiagnosis in pDiagnosisCollection ) {
		if (!pDiagnosis) {
			ASSERT(FALSE);
			continue;
		}
		long lParentID = 0;
		DoRawImportDiagnosis(pSmeexStructure,lParentID,pDiagnosis);
	}
}

void CSmeexHandler::DoRawExportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Kg ^pKG,
	const long &lParentID,
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::DiagnosisPtrCollection ^pDiagnosisCollection)
{
	SmeexDiagnosisMap *pmapDiagnosis = &f_psSmeexOnePatientComm->sPatientInfo.sKg.mapDiagnosis;
	SmeexDiagnosisArray::const_iterator psDiagnosis;
	SmeexDiagnosisMap::const_iterator parDiagnosis = pmapDiagnosis->find(lParentID);
	if( parDiagnosis != pmapDiagnosis->end() ) {
		SmeexDiagnosisArray::const_iterator psDiagnosis;
		for(psDiagnosis=parDiagnosis->second.begin();psDiagnosis!=parDiagnosis->second.end();psDiagnosis++) {
			Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis ^pDiagnosis = pKG->NewDiagnosis();
			if (!pDiagnosis) {
				ASSERT(FALSE);
				return;
			}
			System::String ^strKey = gcnew System::String(BuildCodingEntryKey(psDiagnosis->strCodingEntryCode,psDiagnosis->strCodingEntryName));
			Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::CodingEntry ^ pCodingEntry;
			if (f_mapCodingEntry.TryGetValue(strKey, pCodingEntry)) {
			}
			else {
				Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::GlobalDefinitions ^pGlobalDefinitions = pSmeexStructure->NewGlobalDefinitions();
				if (!pGlobalDefinitions) {
					ASSERT(FALSE);
					return;
				}
				pCodingEntry = pGlobalDefinitions->NewCodingEntry();
				if (!pCodingEntry) {
					ASSERT(FALSE);
					return;
				}
				pCodingEntry->Code = gcnew System::String((TCHAR*)psDiagnosis->strCodingEntryCode);
				pCodingEntry->Name = gcnew System::String((TCHAR*)psDiagnosis->strCodingEntryName);
				f_mapCodingEntry.Add(strKey, pCodingEntry);
			}
			pDiagnosis->CodingEntryPtr = pCodingEntry;
			pDiagnosis->CodingType = psDiagnosis->eCodingType;
			pDiagnosis->Date = System::DateTime::FromOADate(psDiagnosis->dDate);
			pDiagnosis->ID = psDiagnosis->lID;
			if (psDiagnosis->bIsActive!=-1) {
				pDiagnosis->IsActive = (psDiagnosis->bIsActive) ? true : false;
			}
			pDiagnosis->Name = gcnew System::String((TCHAR*)psDiagnosis->strName);
			pDiagnosis->ShortName = gcnew System::String((TCHAR*)psDiagnosis->strShortName);
			if (pDiagnosisCollection) {
				pDiagnosisCollection->Add(pDiagnosis);
			}
			if (psDiagnosis->lID!=lParentID) {
				DoRawExportDiagnosis(pSmeexStructure,pKG,psDiagnosis->lID,pDiagnosis->DiagnosisPtr);
			}
		}
	}
}

void CSmeexHandler::DoRawImportDiagnosis(Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::SmeexStructure ^pSmeexStructure,
				const long &lParentID,
				Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis ^pDiagnosis)
{
	structSmeexDiagnosis sDiagnosis;
	INIT_SMEEXDIAGNOSISSTRUCT(sDiagnosis);
	//
	Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::CodingEntry ^pCodingEntry = pDiagnosis->CodingEntryPtr;
	if (!pCodingEntry) {
		ASSERT(FALSE);
		//return;
	}
	else {
		sDiagnosis.strCodingEntryCode = CString(pCodingEntry->Code);
		sDiagnosis.strCodingEntryName = CString(pCodingEntry->Name);
		sDiagnosis.eCodingType = pDiagnosis->CodingType;
		System::Nullable<System::DateTime> DateValue = pDiagnosis->Date;
		if (DateValue.HasValue) {
			sDiagnosis.dDate = pDiagnosis->Date.Value.ToOADate();
		}
		sDiagnosis.lID = (long)pDiagnosis->ID;
		System::Nullable<bool> BoolValue;
		BoolValue = pDiagnosis->IsActive;
		if (BoolValue.HasValue) {
			sDiagnosis.bIsActive = (pDiagnosis->IsActive.Value==true) ? TRUE : FALSE;
		}
		sDiagnosis.strName = CString(pDiagnosis->Name);
		TRACE("%ls\n",(TCHAR*)sDiagnosis.strName);
		sDiagnosis.strShortName = CString(pDiagnosis->ShortName);
		if (pDiagnosis->DiagnosisPtr) {
			long lSubID = 0;
			long lCount = 0;
			//long lDiagnosisID = sDiagnosis.lID;
			//Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis::DiagnosisPtrCollection pDiagnosisPtrCollection = pDiagnosis->DiagnosisPtr;
			for each ( Vsfm::Smeex::Framework::Common::Classes::fullSMEEX::Diagnosis ^pSubDiagnosis in pDiagnosis->DiagnosisPtr ) {
				if (pSubDiagnosis) {
					long lID = (long)pSubDiagnosis->ID;
					lSubID=lID;
					lCount++;
					//DoRawImportDiagnosis(pSmeexStructure,lDiagnosisID,pSubDiagnosis);
				}
			}
			ASSERT(lCount<=1);
			if (lCount==1) {
				f_mapDiagnosisImportParentID[lSubID] = (long)pDiagnosis->ID;
				long lID;
				if (f_mapDiagnosisImportAddedID.TryGetValue(lSubID, lID)) {
					sDiagnosis.lParentID = lSubID;
				}
			}
		}
		long lDiagParentID;
		if (f_mapDiagnosisImportParentID.TryGetValue((long)pDiagnosis->ID, lDiagParentID)) {
			sDiagnosis.lParentID = lDiagParentID;
		}
		lDiagParentID = sDiagnosis.lParentID;
		SmeexDiagnosisMap *pmapDiagnosis = &f_psSmeexOnePatientComm->sPatientInfo.sKg.mapDiagnosis;
		SmeexDiagnosisMap::iterator parDiagnosis = pmapDiagnosis->find(lDiagParentID);
		if( parDiagnosis == pmapDiagnosis->end() ) {
			SmeexDiagnosisArray arDiag;
			(*pmapDiagnosis)[lDiagParentID] = arDiag;
			parDiagnosis = pmapDiagnosis->find(lDiagParentID);
			ASSERT(parDiagnosis!=pmapDiagnosis->end());
		}
		if( parDiagnosis != pmapDiagnosis->end() ) {
			SmeexDiagnosisArray *p = &parDiagnosis->second;
			p->push_back(sDiagnosis);
			f_mapDiagnosisImportAddedID[sDiagnosis.lID]=sDiagnosis.lID;
		}
	}
}
